#include "libnazgul.h"


void * msgBufferMap(msgPoolData * poolDataTab, int poolIndex, int bufferIndex) {
	void * resultAddr;
	int bufferSize, bufferNb;
	int poolBufferTabFd; 
	msgPoolId poolBufferTabId;

  // TODO: rcuperer l'ID du BufferInfoTab;
  strcpy(poolBufferTabId, poolDataTab[poolIndex].poolId);
  bufferSize=poolDataTab[poolIndex].bufferSize;
  bufferNb=poolDataTab[poolIndex].bufferNb;

  poolBufferTabFd=shm_open(poolBufferTabId,O_RDWR,SHM_DEFAULT_MODE);
  if (poolBufferTabFd<0){
	NZG_ERROR("shm_open",poolBufferTabId);
	goto ERROR;
  }
	
  // mapper le buffer dans l'espace mmoire du processus
  /* on s'arrete juste derriere l'index qui nous intresse */
  resultAddr=mmap(NULL, 
		bufferSize*(bufferIndex+1),  
		PROT_NONE, 
		MAP_SHARED, 
		poolBufferTabFd, 
		(off_t)0);
	if(resultAddr == MAP_FAILED) {
	  NZG_ERROR("mmap", poolBufferTabId);
	  goto ERROR;
	}

	resultAddr=resultAddr +( bufferSize*bufferIndex);

	mprotect(
		resultAddr,
		bufferSize,
		PROT_READ|PROT_WRITE
		);

	close(poolBufferTabFd);

	return resultAddr;
ERROR:
	return NULL;
}
